/*============================================================================
  File:      DmhLocalization.cpp
 
  Summary:   Localization function implementation

  Date:		 June 30, 2004
------------------------------------------------------------------------------
  This file is part of the Microsoft SQL Server Code Samples.
 
  Copyright (C) 2003 Microsoft Corporation.  All rights reserved.
 
This source code is intended only as a supplement to Microsoft
Development Tools and/or on-line documentation.  See these other
materials for detailed information regarding Microsoft code samples.
 
THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY
KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
PARTICULAR PURPOSE.
============================================================================*/

#include "stdafx.h"
#include <atlbase.h>
#include <atlcom.h>
#include <math.h> // Used for log10 - you can omit this
#include "DmhLocalization.h"
#include <stdio.h>
#include "Resource.h"

// Implementation of localization

HRESULT		LoadStringFromID(int	iIDString,  // Resource ID of the string
							 LCID	lcid,		// Locale
							 WCHAR	wchar[],	// Buffer into which string is written
							 INT	ccharMax)	// 1 + size of the buffer
{
	switch (iIDString)
	{
		case IDS_SERVICE_DISPLAY_NAME:
		
			swprintf_s(wchar, ccharMax, L"MyCompanyName Pairwise Linear Regression");
			break;
		
		case IDS_SERVICE_DESCRIPTION:
		
			swprintf_s(wchar, ccharMax, L"Build a linear regression model for every pair of continuous variables in the domain");
			break;
	
		case IDS_MINIMUM_DEPENDENCY_SCORE_DESCR:
	
			swprintf_s(wchar, ccharMax, L"Minimum score needed to include a pair in the browser and in prediction");
			break;
	
		case IDS_DISPLAY_CORRELATION_DESCR:
	
			swprintf_s(wchar, ccharMax, L"Display correlation coefficients instead of linear coefficients when browsing");
			break;
	

		default:
	
			swprintf_s(wchar, ccharMax, L"Unexpected string ID");
	}	

	return S_OK;
}
